/**
 * Copyright (c) 2015-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 * @format
 */

'use strict';function _asyncToGenerator(fn) {return function () {var gen = fn.apply(this, arguments);return new Promise(function (resolve, reject) {function step(key, arg) {try {var info = gen[key](arg);var value = info.value;} catch (error) {reject(error);return;}if (info.done) {resolve(value);} else {return Promise.resolve(value).then(function (value) {step("next", value);}, function (err) {step("throw", err);});}}return step("next");});};}

const fs = require('fs');
const isAbsolutePath = require('absolute-path');































class Module {








  constructor(_ref) {let file = _ref.file,localPath = _ref.localPath,moduleCache = _ref.moduleCache,transformCode = _ref.transformCode;
    if (!isAbsolutePath(file)) {
      throw new Error('Expected file to be absolute path but got ' + file);
    }

    this.localPath = localPath;
    this.path = file;
    this.type = 'Module';

    this._moduleCache = moduleCache;
    this._transformCode = transformCode;
  }

  isHaste() {
    return false;
  }

  getName() {
    return this.localPath;
  }

  getPackage() {
    return this._moduleCache.getPackageForModule(this);
  }

  invalidate() {
    this._sourceCode = null;
  }

  _readSourceCode() {
    if (this._sourceCode == null) {
      this._sourceCode = fs.readFileSync(this.path, 'utf8');
    }

    return this._sourceCode;
  }

  read(transformOptions) {var _this = this;return _asyncToGenerator(function* () {
      const result = yield _this._transformCode(_this,

      null, // Source code is read on the worker
      transformOptions);


      const module = _this;

      return {
        code: result.code,
        dependencies: result.dependencies,
        map: result.map,
        get source() {
          return module._readSourceCode();
        } };})();

  }

  readCached(transformOptions) {
    return null;
  }

  readFresh(transformOptions) {
    return this.read(transformOptions);
  }

  hash() {
    return `Module : ${this.path}`;
  }

  isAsset() {
    return false;
  }

  isPolyfill() {
    return false;
  }}


module.exports = Module;